from request import Request
from response import Response
from static_responder import StaticResponder

import socketserver


class Handler(socketserver.StreamRequestHandler):
    # self.request - client socket
    
    def handle(self):
        request = Request(self.rfile)
        response = Response(self.wfile)
        static_responder = StaticResponder(request, response)

        print(request)
        
        if static_responder.file:
            static_responder.prepare_response()

        else:
            response.add_header('Content-Type', 'text/html')
            response.add_header('Connection', 'close')
            response.set_body('<h1>Hello World!</h1>')

        response.send()
        

ADDRESS = ('localhost', 1027)
socketserver.ThreadingTCPServer.allow_reuse_address = True

with socketserver.ThreadingTCPServer(ADDRESS, Handler) as server:
    server.serve_forever()
